Compare commits

..

No commits in common. "master" and "0.1.0" have entirely different histories.

32 changed files with 47 additions and 763 deletions

View File

@ -1,4 +0,0 @@
{
"name": "ludeeus/action-shellcheck",
"image": "mcr.microsoft.com/devcontainers/base:bullseye"
}

1
.gitattributes vendored
View File

@ -1 +0,0 @@
* text=auto eol=lf

View File

@ -1 +0,0 @@
blank_issues_enabled: false

View File

@ -1,24 +0,0 @@
---
name: Feature request
about: Suggest an idea for this project
labels: "Feature Request"
---
## Checklist
- [ ] This Feature Request only contains 1 request (if you have multiple open multiple feature requests).
## The idea
A good description of what you are suggesting.
## Implementation
How do you see this being implemented?
## Alternatives
Are there any alternative solutions or features you've considered?
## Additional context

View File

@ -1,14 +0,0 @@
---
name: "Issue"
about: For issue reporting.
labels: "bug"
---
## Describe the issue
A clear and concise description of what the issue is.
### Links
- **Link to action run:**
- **Link to action configuration:**

View File

@ -1,8 +0,0 @@
version: 2
updates:
- package-ecosystem: "github-actions"
directory: "/"
schedule:
interval: weekly
time: "06:00"
open-pull-requests-limit: 10

8
.github/main.workflow vendored Normal file
View File

@ -0,0 +1,8 @@
workflow "Trigger: Push" {
on = "push"
resolves = ["Shellcheck"]
}
action "Shellcheck" {
uses = "ludeeus/action-shellcheck@master"
}

View File

@ -1,47 +0,0 @@
name: 'additional_files'
on:
push:
branches:
- "master"
pull_request:
branches:
- "master"
permissions: {}
jobs:
additional_files:
name: additional_files
runs-on: ${{ matrix.os }}
strategy:
matrix:
os:
- ubuntu-latest
- macos-latest
steps:
- name: Checkout
uses: actions/checkout@v4.1.0
- name: Run ShellCheck
uses: ./
id: check
with:
additional_files: run finish discovery
ignore_paths: ignore
scandir: testfiles
- name: Verify check
run: |
expect="testfiles/scandir/run"
if [[ ! "${{ steps.check.outputs.files }}" =~ testfiles/scandir/run ]];then
echo "::error:: Expected file testfiles/scandir/run not found in ${{ steps.check.outputs.files }}"
exit 1
elif [[ ! "${{ steps.check.outputs.files }}" =~ testfiles/scandir/finish ]];then
echo "::error:: Expected file testfiles/scandir/finish not found in ${{ steps.check.outputs.files }}"
exit 1
elif [[ ! "${{ steps.check.outputs.files }}" =~ testfiles/scandir/discovery ]];then
echo "::error:: Expected file testfiles/scandir/discovery not found in ${{ steps.check.outputs.files }}"
exit 1
fi

View File

@ -1,44 +0,0 @@
name: 'check_together'
on:
push:
branches:
- "master"
pull_request:
branches:
- "master"
permissions: {}
jobs:
check_together:
name: check_together
runs-on: ${{ matrix.os }}
strategy:
matrix:
os:
- ubuntu-latest
- macos-latest
steps:
- name: Checkout
uses: actions/checkout@v4.1.0
- name: Run ShellCheck
uses: ./
id: check
with:
ignore_paths: ignore
check_together: true
- name: Verify check
run: |
expect="testfiles/test.bash"
notexpect="testfiles/ignore/ignore.bash"
if [[ ! "${{ steps.check.outputs.files }}" =~ $expect ]];then
echo "::error:: Expected file $expect not found in ${{ steps.check.outputs.files }}"
exit 1
elif [[ "${{ steps.check.outputs.files }}" =~ $notexpect ]];then
echo "::error:: Expected file $notexpect found in ${{ steps.check.outputs.files }}"
exit 1
fi

View File

@ -1,44 +0,0 @@
name: 'ignore_names'
on:
push:
branches:
- "master"
pull_request:
branches:
- "master"
permissions: {}
jobs:
ignore_names:
name: ignore_names
runs-on: ${{ matrix.os }}
strategy:
matrix:
os:
- ubuntu-latest
- macos-latest
steps:
- name: Checkout
uses: actions/checkout@v4.1.0
- name: Run ShellCheck
uses: ./
id: check
with:
ignore_paths: ignore
ignore_names: ignore_single_file.sh
- name: Verify check
run: |
expect="testfiles/test.bash"
notexpect="testfiles/ignore_single_file.sh"
if [[ ! "${{ steps.check.outputs.files }}" =~ $expect ]];then
echo "::error:: Expected file $expect not found in ${{ steps.check.outputs.files }}"
exit 1
elif [[ "${{ steps.check.outputs.files }}" =~ $notexpect ]];then
echo "::error:: Expected file $notexpect found in ${{ steps.check.outputs.files }}"
exit 1
fi

View File

@ -1,74 +0,0 @@
name: "ignore_paths"
on:
push:
branches:
- "master"
pull_request:
branches:
- "master"
permissions: {}
jobs:
ignore_paths:
name: ignore_paths
runs-on: ${{ matrix.os }}
strategy:
matrix:
os:
- ubuntu-latest
- macos-latest
steps:
- name: Checkout
uses: actions/checkout@v4.1.0
- name: Run ShellCheck
uses: ./
id: check
with:
ignore_paths: ignore ./testfiles/ignore_some/duplicate_name.bash **/ignore_some/ignore.bash
- name: Verify check
run: |
fail=false
# verify a non-ignored path is not excluded
expect="testfiles/test.bash"
if [[ ! "${{ steps.check.outputs.files }}" =~ $expect ]];then
echo "::error:: Expected file $expect not found in ${{ steps.check.outputs.files }}"
fail=true
fi
# verify a file with the same name as an ignored file but at a
# different path is not excluded
expect="testfiles/duplicate_name.bash"
if [[ ! "${{ steps.check.outputs.files }}" =~ $expect ]];then
echo "::error:: Expected file $expect not found in ${{ steps.check.outputs.files }}"
fail=true
fi
# verify ignored full path excluded
notexpect="testfiles/ignore_some/duplicate_name.bash"
if [[ "${{ steps.check.outputs.files }}" =~ $notexpect ]];then
echo "::error:: Unexpected file $notexpect found in ${{ steps.check.outputs.files }}"
fail=true
fi
# verify ignored directory excluded
notexpect="testfiles/ignore/ignore.bash"
if [[ "${{ steps.check.outputs.files }}" =~ $notexpect ]];then
echo "::error:: Unexpected file $notexpect found in ${{ steps.check.outputs.files }}"
fail=true
fi
# verify ignored glob excluded
notexpect="testfiles/ignore_some/ignore.bash"
if [[ "${{ steps.check.outputs.files }}" =~ $notexpect ]];then
echo "::error:: Unexpected file $notexpect found in ${{ steps.check.outputs.files }}"
fail=true
fi
if $fail;then
exit 1
fi

View File

@ -1,63 +0,0 @@
name: 'scandir'
on:
push:
branches:
- "master"
pull_request:
branches:
- "master"
permissions: {}
jobs:
scandir:
name: scandir
runs-on: ${{ matrix.os }}
strategy:
matrix:
os:
- ubuntu-latest
- macos-latest
steps:
- name: Checkout
uses: actions/checkout@v4.1.0
- name: Run ShellCheck
uses: ./
id: one
with:
scandir: testfiles/scandir
- name: Verify check
run: |
expect="testfiles/scandir/run[[:space:]]me.bash"
notexpect="testfiles/test.bash"
if [[ ! "${{ steps.one.outputs.files }}" =~ $expect ]];then
echo "::error:: Expected file $expect not found in ${{ steps.one.outputs.files }}"
exit 1
elif [[ "${{ steps.one.outputs.files }}" =~ $notexpect ]];then
echo "::error:: Expected file $notexpect found in ${{ steps.one.outputs.files }}"
exit 1
fi
- name: Run ShellCheck
uses: ./
id: two
with:
scandir: './testfiles/scandir'
ignore_paths: ignore
- name: Verify check
run: |
expect="testfiles/scandir/test.bash"
notexpect="testfiles/test.bash"
if [[ ! "${{ steps.two.outputs.files }}" =~ $expect ]];then
echo "::error:: Expected file $expect not found in ${{ steps.two.outputs.files }}"
exit 1
elif [[ "${{ steps.two.outputs.files }}" =~ $notexpect ]];then
echo "::error:: Expected file $notexpect found in ${{ steps.two.outputs.files }}"
exit 1
fi

16
Dockerfile Normal file
View File

@ -0,0 +1,16 @@
FROM debian:latest
COPY runaction.sh /runaction.sh
RUN chmod +x /runaction.sh
RUN apt update
RUN apt install -y shellcheck
ENTRYPOINT ["/runaction.sh"]
LABEL "name"="shellcheck"
LABEL "maintainer"="Ludeeus <ludeeus@gmail.com>"
LABEL "version"="0.1.0"
LABEL "com.github.actions.name"="shellcheck"
LABEL "com.github.actions.description"="Run shell check on ALL sh files in the repository."
LABEL "com.github.actions.icon"="terminal"
LABEL "com.github.actions.color"="black"

View File

@ -1,6 +1,6 @@
MIT License
Copyright (c) 2020 ludeeus
Copyright (c) 2019 ludeeus
Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal

176
README.md
View File

@ -1,168 +1,24 @@
# ShellCheck
# SHELLCHECK
_GitHub action for [ShellCheck](https://www.shellcheck.net/)._
[![BuyMeCoffee][buymecoffeebedge]][buymecoffee]
_Run shellcheck on ALL sh files in the repository._
## Example
```yaml
on:
push:
branches:
- master
```
workflow "Shellcheck" {
on = "push"
resolves = [
"Shellcheck",
]
}
name: "Trigger: Push action"
permissions: {}
jobs:
shellcheck:
name: Shellcheck
runs-on: ubuntu-latest
steps:
- uses: actions/checkout@v4
- name: Run ShellCheck
uses: ludeeus/action-shellcheck@master
action "Shellcheck" {
uses = "ludeeus/actions/shellcheck@master"
}
```
## ShellCheck options
You can pass any supported ShellCheck option or flag with the `SHELLCHECK_OPTS` env key in the job definition.
Some examples include:
- To disable specific checks (eg: `-e SC2059 -e SC2034 -e SC1090`)
- To test against different shells (eg: `-s dash` or `-s ksh`)
example:
```yaml
...
- name: Run ShellCheck
uses: ludeeus/action-shellcheck@master
env:
SHELLCHECK_OPTS: -e SC2059 -e SC2034 -e SC1090
```
## Ignore paths and names
You can use the `ignore_paths` and `ignore_names` input to disable specific directories and files.
These are passed as environment variables, and should evaluate to a single space-separated string.
It may be convenient to use [`>-`](https://yaml.org/spec/1.2.2/#65-line-folding) for readability if you have multiple selectors.
```text
sample structure:
sample/directory/with/files/ignoreme/test.sh
sample/directory/with/files/ignoremetoo/test.sh
sample/directory/with/files/test.sh
sample/directory/with/files/ignorable.sh
```
example:
```yaml
...
- name: Run ShellCheck
uses: ludeeus/action-shellcheck@master
with:
ignore_paths: >-
ignoreme
ignoremetoo
ignore_names: ignorable.sh
```
This will skip `sample/directory/with/files/ignoreme/test.sh`, `sample/directory/with/files/ignoremetoo/test.sh` and `sample/directory/with/files/ignorable.sh`.
You can also ignore specific files using full paths or glob patterns with `ignore_paths`.
example:
```yaml
...
- name: Run ShellCheck
uses: ludeeus/action-shellcheck@master
with:
ignore_paths: ./sample/directory/with/files/ignorable.sh **/ignoreme/test.sh
```
This will skip `sample/directory/with/files/ignorable.sh` and `sample/directory/with/files/ignoreme/test.sh`.
## Minimum severity of errors to consider (error, warning, info, style)
You can use the `severity` input to not fail until specified severity is met, for example fail only if there are errors in scripts but ignore styling, info and warnings.
example:
```yaml
...
- name: Run ShellCheck
uses: ludeeus/action-shellcheck@master
with:
severity: error
```
## Run shellcheck with all paths in a single invocation
If you run into SC1090/SC1091 errors you may need to tell shellcheck to check
all files at once:
```yaml
...
- name: Run ShellCheck
uses: ludeeus/action-shellcheck@master
with:
check_together: 'yes'
```
This can turn into a problem if you have enough script files to overwhelm the
maximum argv length on your system.
## Run shellcheck only in a single directory
If you have multiple directories with scripts, but only want to scan
one of them, you can use the following configuration:
```yaml
...
- name: Run ShellCheck
uses: ludeeus/action-shellcheck@master
with:
scandir: './scripts'
```
## Scan for additional files
If you need to scan for unusual files, you can use the `additional_files` key.
```yaml
...
- name: Run ShellCheck
uses: ludeeus/action-shellcheck@master
with:
additional_files: 'run finish'
```
## Change output format
Shellcheck can print output in these formats: `checkstyle`, `diff`, `gcc`, `json`, `json1`, `quiet`, `tty`. See some examples [here](https://github.com/koalaman/shellcheck/wiki/Integration#pick-the-output-format-that-makes-your-life-easier).
- `tty` has multi-line log messages
- `gcc` has single-line log messages
```yaml
...
- name: Run ShellCheck
uses: ludeeus/action-shellcheck@master
with:
format: tty
```
## Run a specific version of Shellcheck
If running the latest stable version of Shellcheck is not to your liking, you can specify a concrete version of Shellcheck to be used. When specifying a custom version, please use any of the released versions listed in the [Shellcheck repository](https://github.com/koalaman/shellcheck/tags).
```yaml
...
- name: Run ShellCheck
uses: ludeeus/action-shellcheck@master
with:
version: v0.9.0
```
[buymecoffee]: https://www.buymeacoffee.com/ludeeus
[buymecoffeebedge]: https://camo.githubusercontent.com/cd005dca0ef55d7725912ec03a936d3a7c8de5b5/68747470733a2f2f696d672e736869656c64732e696f2f62616467652f6275792532306d6525323061253230636f666665652d646f6e6174652d79656c6c6f772e737667

View File

@ -1,225 +0,0 @@
name: "ShellCheck"
author: "Ludeeus <hi@ludeeus.dev>"
description: "GitHub action for ShellCheck."
inputs:
additional_files:
description: "A space separated list of additional filename to check"
required: false
default: ""
ignore:
description: "Paths to ignore when running ShellCheck"
required: false
default: ""
deprecationMessage: "Use ignore_paths or ignore_names instead."
ignore_paths:
description: "Paths to ignore when running ShellCheck"
required: false
default: ""
ignore_names:
description: "Names to ignore when running ShellCheck"
required: false
default: ""
severity:
description: "Minimum severity of errors to consider. Options: [error, warning, info, style]"
required: false
default: ""
check_together:
description: "Run shellcheck on _all_ files at once, instead of one at a time"
required: false
default: ""
scandir:
description: "Directory to be searched for files. Defaults to ."
required: false
default: "."
disable_matcher:
description: "Set to true to skip using problem-matcher"
required: false
default: "false"
deprecationMessage: "There are no problem-matchers, this setting does not do anything."
format:
description: "Output format (checkstyle, diff, gcc, json, json1, quiet, tty)"
required: false
default: "gcc"
version:
description: "Specify a concrete version of ShellCheck to use"
required: false
default: "stable"
outputs:
files:
description: A list of files with issues
value: ${{ steps.check.outputs.filepaths }}
options:
description: The options used
value: ${{ steps.options.outputs.options }}
branding:
icon: "terminal"
color: "gray-dark"
runs:
using: "composite"
steps:
- name: Download shellcheck
shell: bash
env:
INPUT_VERSION: ${{ inputs.version }}
run: |
if [[ "${{ runner.os }}" == "macOS" ]]; then
osvariant="darwin"
else
osvariant="linux"
fi
baseurl="https://github.com/koalaman/shellcheck/releases/download"
curl -Lso "${{ github.action_path }}/sc.tar.xz" \
"${baseurl}/${INPUT_VERSION}/shellcheck-${INPUT_VERSION}.${osvariant}.x86_64.tar.xz"
tar -xf "${{ github.action_path }}/sc.tar.xz" -C "${{ github.action_path }}"
mv "${{ github.action_path }}/shellcheck-${INPUT_VERSION}/shellcheck" \
"${{ github.action_path }}/shellcheck"
- name: Display shellcheck version
shell: bash
run: |
"${{ github.action_path }}/shellcheck" --version
- name: Set options
shell: bash
id: options
env:
INPUT_SEVERITY: ${{ inputs.severity }}
INPUT_FORMAT: ${{ inputs.format }}
run: |
declare -a options
if [[ -n "${INPUT_SEVERITY}" ]]; then
options+=("-S ${INPUT_SEVERITY}")
fi
options+=("--format=${INPUT_FORMAT}")
echo "options=${options[@]}" >> $GITHUB_OUTPUT
- name: Gather excluded paths
shell: bash
id: exclude
env:
INPUT_IGNORE: ${{ inputs.ignore }}
INPUT_IGNORE_PATHS: ${{ inputs.ignore_paths }}
INPUT_IGNORE_NAMES: ${{ inputs.ignore_names }}
run: |
declare -a excludes
set -f # temporarily disable globbing so that globs in input aren't expanded
excludes+=("! -path *./.git/*")
excludes+=("! -path *.go")
excludes+=("! -path */mvnw")
if [[ -n "${INPUT_IGNORE}" ]]; then
for path in ${INPUT_IGNORE}; do
excludes+=("! -path *./$path/*")
excludes+=("! -path */$path/*")
excludes+=("! -path $path")
done
else
for path in ${INPUT_IGNORE_PATHS}; do
excludes+=("! -path *./$path/*")
excludes+=("! -path */$path/*")
excludes+=("! -path $path")
done
fi
for name in ${INPUT_IGNORE_NAMES}; do
excludes+=("! -name $name")
done
echo "excludes=${excludes[@]}" >> $GITHUB_OUTPUT
set +f # re-enable globbing
- name: Gather additional files
shell: bash
id: additional
env:
INPUT_ADDITIONAL_FILES: ${{ inputs.additional_files }}
run: |
declare -a files
for file in ${INPUT_ADDITIONAL_FILES}; do
files+=("-o -name *$file")
done
echo "files=${files[@]}" >> $GITHUB_OUTPUT
- name: Run the check
shell: bash
id: check
env:
INPUT_SCANDIR: ${{ inputs.scandir }}
INPUT_CHECK_TOGETHER: ${{ inputs.check_together }}
INPUT_EXCLUDE_ARGS: ${{ steps.exclude.outputs.excludes }}
INPUT_ADDITIONAL_FILE_ARGS: ${{ steps.additional.outputs.files }}
INPUT_SHELLCHECK_OPTIONS: ${{ steps.options.outputs.options }}
run: |
statuscode=0
declare -a filepaths
shebangregex="^#! */[^ ]*/(env *)?[abk]*sh"
set -f # temporarily disable globbing so that globs in inputs aren't expanded
while IFS= read -r -d '' file; do
filepaths+=("$file")
done < <(find "${INPUT_SCANDIR}" \
${INPUT_EXCLUDE_ARGS} \
-type f \
'(' \
-name '*.bash' \
-o -name '.bashrc' \
-o -name 'bashrc' \
-o -name '.bash_aliases' \
-o -name '.bash_completion' \
-o -name '.bash_login' \
-o -name '.bash_logout' \
-o -name '.bash_profile' \
-o -name 'bash_profile' \
-o -name '*.ksh' \
-o -name 'suid_profile' \
-o -name '*.zsh' \
-o -name '.zlogin' \
-o -name 'zlogin' \
-o -name '.zlogout' \
-o -name 'zlogout' \
-o -name '.zprofile' \
-o -name 'zprofile' \
-o -name '.zsenv' \
-o -name 'zsenv' \
-o -name '.zshrc' \
-o -name 'zshrc' \
-o -name '*.sh' \
-o -path '*/.profile' \
-o -path '*/profile' \
-o -name '*.shlib' \
${INPUT_ADDITIONAL_FILE_ARGS} \
')' \
-print0)
while IFS= read -r -d '' file; do
head -n1 "$file" | grep -Eqs "$shebangregex" || continue
filepaths+=("$file")
done < <(find "${INPUT_SCANDIR}" \
${INPUT_EXCLUDE_ARGS} \
-type f ! -name '*.*' -perm /111 \
-print0)
if [[ -n "${INPUT_CHECK_TOGETHER}" ]]; then
"${{ github.action_path }}/shellcheck" \
${INPUT_SHELLCHECK_OPTIONS} \
"${filepaths[@]}" || statuscode=$?
else
for file in "${filepaths[@]}"; do
"${{ github.action_path }}/shellcheck" \
${INPUT_SHELLCHECK_OPTIONS} \
"$file" || statuscode=$?
done
fi
echo "filepaths=${filepaths[@]}" >> $GITHUB_OUTPUT
echo "statuscode=$statuscode" >> $GITHUB_OUTPUT
set +f # re-enable globbing
- name: Exit action
shell: bash
run: exit ${{steps.check.outputs.statuscode}}

6
runaction.sh Normal file
View File

@ -0,0 +1,6 @@
#!/bin/bash
cd "$GITHUB_WORKSPACE" || exit 1
find . -name \*.sh -exec shellcheck {} +
find . -name \*.bashrc -exec shellcheck {} +
find . -name \*.bash_profile -exec shellcheck {} +

View File

@ -1,6 +0,0 @@
/* C code test file
* file that should not be matched for shellcheck runs
*/
int main(void) {
return 0;
}

View File

@ -1,3 +0,0 @@
#!/bin/bash
test="test"
echo "$test"

View File

@ -1,3 +0,0 @@
#!/bin/bash
test="test"
echo "$test"

View File

@ -1,4 +0,0 @@
#!/usr/bin/sh
test="test"
echo "$test"

View File

@ -1,3 +0,0 @@
#!/bin/bash
test="test"
echo "$test"

View File

@ -1,3 +0,0 @@
#!/bin/bash
test="test"
echo "$test"

View File

@ -1,3 +0,0 @@
#!/bin/bash
test="test"
echo "$test"

View File

@ -1,3 +0,0 @@
#!/usr/bin/env bashio
echo "hi"

View File

@ -1,5 +0,0 @@
#!/usr/bin/env bashio
hi="hi"
echo "$hi"

View File

@ -1,3 +0,0 @@
#!/usr/bin/env bash
echo "hi"

View File

@ -1,3 +0,0 @@
#!/usr/bin/env bash
echo "I love spaces"

View File

@ -1,3 +0,0 @@
#!/bin/bash
test="test"
echo "$test"

View File

@ -1,4 +0,0 @@
#!/bin/bash
test="test"
echo "$test"

View File

@ -1,3 +0,0 @@
#!/bin/bash
test="test"
echo "$test"

View File

@ -1,4 +0,0 @@
#!/usr/bin/sh
test="test"
echo "$test"